<template>
  <div>
    <v-card tile flat v-if="loading && inventory === null" height="40">
          <div class="text-center">
              Fetching data ...
            <v-progress-circular indeterminate color="primary" :width="3" :size="32"></v-progress-circular>
          </div>
      </v-card>
      <v-card flat tile align="center" justify="center" v-if="!loading && inventory === null">
            <v-card-text>
              No inventory found matching this criteria.
            </v-card-text>
      </v-card>
      <createRole  @stored="stored()"></createRole>

      <v-data-table
      :headers="headers"
      :items="inventory"
      class="elevation-1 main-table px-2"
      hide-default-footer
      disable-pagination
      item-key="id"
      v-if="inventory !== null"
      >
       <template v-slot:item.name="{ item }">
          {{ item.name.split('::').pop() }}
        </template>

        <template v-slot:item.description="{ item }">
          <v-tooltip
            right
            allow-overflow
            color="#333"
            max-width="250"
            v-if="item.description"
          >
            <template v-slot:activator="{ on, attrs }">
              <div
                class="text-truncate"
                style="width: 250px"
                v-bind="attrs"
                v-on="on"
              >
                {{ item.description || 'n/a' }}
              </div>
            </template>
            <span>{{ item.description }}</span>
          </v-tooltip>
          <span v-else>n/a</span>
        </template>

        <!-- <template v-slot:item.registered_at="{ item }">
          <span class=""> {{ getFormatedUTCTime(item.registered_at) }}</span>
        </template> -->
          <template v-slot:item.actions="{ item }">
          <v-btn
            text
            small
            color="primary"
            class="ttn caption light-primary no-transform"
            @click="inventory = item"
          >
            Edit
          </v-btn>
        </template>
      </v-data-table>

  </div>
</template>
<script>
import { mapMutations, mapGetters, mapState, mapActions } from 'vuex';

export default {
  name: 'Inventory',
  components: {
    createRole: () => import('./create'),
    // editRole: () => import('./edit'),
  },

  data() {
    return {
      loading: false,
      page: 1,
      inventory: null,
      // role: null,
      headers: [
        {
          text: 'SKU',
          align: 'start',
          sortable: false,
          value: 'sku',
        },
        { text: 'Product', value: 'name' },
        { text: 'category', value: 'category' },
        { text: 'Cost', value: 'cost' },
        { text: 'Price', value: 'price' },

        { text: 'Description', value: 'description', width: '300' },

        { text: 'Actions', value: 'actions' },

      ],
    };
  },

  async mounted() {
    await this.retrieveInventory();
  },
  methods: {
    ...mapActions(['axiosGetRequest']),
    async retrieveInventory() {
      this.loading = true;
      this.inventory = null;

      const payload = {};
      // const endpoint = `FAQs/active`;

      const fullPayload = {
        app: process.env.VUE_APP_ROOT_API,
        params: payload,
        endpoint: '/inventory',
      };

      try {
        const response = await this.axiosGetRequest(fullPayload);
        this.inventory = response.status === 200 ? response.data : null;
        this.loading = false;

        return response;
      } catch (error) {
        this.loading = false;
        return null;
      }
    },

    stored() {
      this.retrieveRoles();
    },

    updated() {
      this.role = null;
      this.retrieveRoles();
    },
  },

};
</script>

<style>

</style>
